"use strict";

var _require = require("../dist/index"),
    createAction = _require.createAction,
    createState = _require.createState;

test("Should do update once only though actions dispatch many time", function () {
  var state1 = createState(1);
  var state2 = createState(2);
  var callback = jest.fn();
  state2.subscribe(callback);
  var action1 = createAction([state1], function (state1) {
    state1(state1() + 1);
    action2();
    action2();
  });
  var action2 = createAction([state2], function (state2) {
    state2(state2() + 1);
  });
  action1();
  expect(state1.value).toBe(2);
  expect(state2.value).toBe(4);
  expect(callback.mock.calls.length).toBe(1);
});
//# sourceMappingURL=simpleState.js.map